package de.rki.coronawarnapp.bugreporting.debuglog.internal

import de.rki.coronawarnapp.util.threads.NamedThreadFactory
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.SupervisorJob
import kotlinx.coroutines.asCoroutineDispatcher
import java.util.concurrent.Executors
import javax.inject.Qualifier
import kotlin.coroutines.CoroutineContext

object DebugLoggerScope : CoroutineScope {
    val dispatcher = Executors.newFixedThreadPool(
        4,
        NamedThreadFactory("DebugLogger")
    ).asCoroutineDispatcher()
    override val coroutineContext: CoroutineContext = SupervisorJob() + dispatcher
}

@Qualifier
@MustBeDocumented
@Retention(AnnotationRetention.RUNTIME)
annotation class DebuggerScope
